/**
 * 适配处理
 */
var fit_offset = 0, innerWidth = window.innerWidth, innerHeight = window.innerHeight;
if (innerWidth === 375 && (innerHeight === 685 || innerHeight === 724 || innerHeight === 768) && window.devicePixelRatio === 3) {
    fit_offset = 32;
}

/**
 * API接口信息
 * @type {string}
 */
var api_url = navigator.userAgent.indexOf("Html5Plus") > -1 ? 'http://app.test.leftlady.com/' : 'http://app.zuoan.dev.zleo183.com/';
var app_key = '10111764';
var app_secret = 'q7c83666ffaf0d12a3f9a435c7347945';

/**
 * 时间戳
 * @returns {string}
 */
var timestamp = function () {
    return (Date.parse(new Date()) / 1000).toString();
};

/**
 * 时间
 * @returns {string}
 */
var datetime = function () {
    return new Date().toLocaleString();
}

/**
 * 遮罩
 */
var mask = mui.createMask();

/**
 * 判断是否是手机客户端
 * @returns {boolean}
 */
var is_plus = function () {
    if (navigator.userAgent.indexOf("Html5Plus") > -1) {
        return true;
    }
    return false;
}

/**
 * 接口签名功能
 * @param params
 * @param app_secret
 * @returns {string}
 */
var sign = function (params, app_secret) {
    params = ksort(params);
    var stringToBeSigned = app_secret;

    mui.each(params, function (index, item) {
        stringToBeSigned += index + item;
    })
    stringToBeSigned += app_secret;
    return md5(stringToBeSigned).toUpperCase();
}

/**
 * 排序，类似PHP的功能
 * @param inputArr
 * @param sort_flags
 * @returns {boolean|{}}
 */
var ksort = function (inputArr, sort_flags) {
    var tmp_arr = {},
        keys = [],
        sorter, i, k, that = this,
        strictForIn = false,
        populateArr = {};

    switch (sort_flags) {
        case 'SORT_STRING':
            // compare items as strings
            sorter = function (a, b) {
                return that.strnatcmp(a, b);
            };
            break;
        case 'SORT_LOCALE_STRING':
            // compare items as strings, original by the current locale (set with  i18n_loc_set_default() as of PHP6)
            var loc = this.i18n_loc_get_default();
            sorter = this.php_js.i18nLocales[loc].sorting;
            break;
        case 'SORT_NUMERIC':
            // compare items numerically
            sorter = function (a, b) {
                return ((a + 0) - (b + 0));
            };
            break;
        // case 'SORT_REGULAR': // compare items normally (don't change types)
        default:
            sorter = function (a, b) {
                var aFloat = parseFloat(a),
                    bFloat = parseFloat(b),
                    aNumeric = aFloat + '' === a,
                    bNumeric = bFloat + '' === b;
                if (aNumeric && bNumeric) {
                    return aFloat > bFloat ? 1 : aFloat < bFloat ? -1 : 0;
                } else if (aNumeric && !bNumeric) {
                    return 1;
                } else if (!aNumeric && bNumeric) {
                    return -1;
                }
                return a > b ? 1 : a < b ? -1 : 0;
            };
            break;
    }

    // Make a list of key names
    for (k in inputArr) {
        if (inputArr.hasOwnProperty(k)) {
            keys.push(k);
        }
    }
    keys.sort(sorter);

    // BEGIN REDUNDANT
    this.php_js = this.php_js || {};
    this.php_js.ini = this.php_js.ini || {};
    // END REDUNDANT
    strictForIn = this.php_js.ini['phpjs.strictForIn'] && this.php_js.ini['phpjs.strictForIn'].local_value && this.php_js.ini['phpjs.strictForIn'].local_value !== 'off';
    populateArr = strictForIn ? inputArr : populateArr;

    // Rebuild array with sorted key names
    for (i = 0; i < keys.length; i++) {
        k = keys[i];
        tmp_arr[k] = inputArr[k];
        if (strictForIn) {
            delete inputArr[k];
        }
    }
    for (i in tmp_arr) {
        if (tmp_arr.hasOwnProperty(i)) {
            populateArr[i] = tmp_arr[i];
        }
    }

    return strictForIn || populateArr;
}

/**
 * 接口封装
 * @param method
 * @param params
 * @param success
 */
mui.app_post = function (method, params, success) {
    /*提交的接口数据*/
    var data = {
        app_key: app_key,
        timestamp: timestamp(),
        format: 'json',
        v: '1.0'
    }
    /*用户登录的数据*/
    if (is_plus()) {
        var uid = localStorage.getItem('uid'), session = localStorage.getItem('session');
        if (uid != '' && uid != null && session != '' && session != null) {
            data.uid = uid;
            data.session = session;
        }
        var unique_id = localStorage.getItem('unique_id');
        if (unique_id != '' && unique_id != null) {
            data.unique_id = unique_id;
        }
        else {
            unique_id = md5(timestamp() + Math.random() + Math.random());
            localStorage.setItem('unique_id', unique_id);
            data.unique_id = unique_id;
        }
        data.device = JSON.stringify(plus.device);
    }
    /*提交的其它数据*/
    params.data = params.data ? mui.extend(params.data, data) : data;
    params.data.sign = sign(params.data, app_secret);

    /*其它参数*/
    params.dataType = params.dataType ? params.dataType : 'json';//服务器返回json格式数据；
    params.type = params.type ? params.type : 'post';//HTTP请求类型；
    params.timeout = params.timeout ? params.timeout : 10000;//超时时间设置为20秒；
    if (is_plus()) {
        params.beforeSend = function () {
            plus.nativeUI.showWaiting('加载中...');
        }
        params.complete = function () {
            plus.nativeUI.closeWaiting();
        }
    }
    params.success = params.success ? params.success : function (data) {//成功处理
        console.log('服务器返回：' + JSON.stringify(data));
        if (data.code == '34') {
            localStorage.removeItem('uid');
            localStorage.removeItem('session');
            mui.openWindow({
                url: '_www/login.html#' + timestamp(),
                show: {
                    aniShow: 'slide-in-bottom'
                }
            });
            mui.toast(data.msg);
            return;
        }
        success(data);
    }
    params.error = params.error ? params.error : function (xhr, type, errorThrown) {//异常处理；
        console.log(errorThrown);
    }
    console.log(JSON.stringify('-------' + datetime() + '--app-ajax------'));
    console.log('URL：' + JSON.stringify(api_url + method));
    console.log('POST：' + JSON.stringify(params));
    mui.ajax(api_url + method, params);
};

/**
 * 关闭所有页面打开新页面
 * @param path
 */
mui.open_page = function (path) {
    /*获取所有Webview窗口*/
    var curr = plus.webview.currentWebview();
    var wvs = plus.webview.all();
    for (var i = 0, len = wvs.length; i < len; i++) {
        /*关闭除主页页面外的其他页面*/
        if (wvs[i].getURL() == curr.getURL()) {
            continue;
        }
        plus.webview.close(wvs[i]);
    }
    /*打开login页面后再关闭主页面*/
    plus.webview.open(path);
    curr.close();
}
/**
 * 自动聚焦
 * @param $id
 */
mui.autofocus = function ($id) {
    if (is_plus()) {
        if (mui.os.ios) {
            var webView = plus.webview.currentWebview().nativeInstanceObject();
            webView.plusCallMethod({"setKeyboardDisplayRequiresUserAction": false});
            document.getElementById($id).focus();
        }
        else {
            document.getElementById($id).focus();
        }
    }
    else {
        document.getElementById($id).focus();
    }
}
mui.plusReady(function () {
    console.log('WebviewInfo：' + JSON.stringify(plus.webview.currentWebview()))
});

/***************支付***************/
var wxChannel = null; // 微信支付
var aliChannel = null; // 支付宝支付
var channel = null;
mui.plusReady(function () {
    // 获取支付通道
    plus.payment.getChannels(function (channels) {
        for (var i in channels) {
            if (channels[i].id == "wxpay") {
                wxChannel = channels[i];
            } else {
                aliChannel = channels[i];
            }
        }
    }, function (e) {
        alert("获取支付通道失败：" + e.message);
    });
});
var pay = function(id, pay_url) {
    // 从服务器请求支付订单
    if (id == 'alipayapp') {
        channel = aliChannel;
    }
    else if (id == 'wxpayapp') {
        channel = wxChannel;
    }
    else {
        plus.nativeUI.alert("不支持此支付通道！", null, "捐赠");
        return;
    }
    console.log(JSON.stringify(channel));
    mui.app_post(pay_url,{},function (data) {
        plus.payment.request(channel, data.info, function (result) {
            plus.nativeUI.alert("支付成功！", function () {
                var curr = plus.webview.currentWebview();
                curr.close();
            });
        }, function (error) {
            plus.nativeUI.alert("支付失败：" + error.code);
        });
    });
}

/**
 * 图片base64
 * @param img
 * @returns {string}
 */
var imgToBase64 = function (img) {
    var canvas = document.createElement("canvas");
    canvas.width = img.width;
    canvas.height = img.height;
    var ctx = canvas.getContext("2d");
    ctx.drawImage(img, 0, 0, img.width, img.height);
    var ext = img.src.substring(img.src.lastIndexOf(".") + 1).toLowerCase();
    var dataURL = canvas.toDataURL("image/" + ext);
    console.log(dataURL);
    return dataURL;
}